-module(children).
-behaviour(gen_server).

-export([start_link/0]).

-export([init/1,
        handle_call/3,
        handle_cast/2,
        handle_info/2,
        terminate/2,
        code_change/3]).

start_link() ->
    gen_server:start_link(?MODULE, [], []).


init([]) ->
    process_flag(trap_exit, true),
    error_logger:info_report([{started, self()}]),
    {ok, nil}.

handle_call(Req, _From, St) ->
    {reply, {error, Req}, St}.

handle_cast(_Req, St) ->
    {noreply, St}.

handle_info(_Req, St) ->
    {noreply, St}.

terminate(Reason, _St) ->
    timer:sleep(1000),
    error_logger:info_report([{stopped, {child, self()}}, {reason, Reason}]),
    ok.

code_change(_OldVsn, St, _Extra) ->
    {noreply, St}.
